#include "ocsinv.h"

#include <sys/types.h>
#include <time.h>
#include <netdb.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>


char* get_device_id()
{
	static char* device_id = NULL;
 
	char hostname[MAXHOSTNAMELEN];
	char buf[256];
	struct tm* now;
	time_t clock;
	FILE *f;
	char *fname = NULL;

	/* use saved value, if any */
	   
  if (device_id)
  	return device_id;


	/* Use the value of -f switch if specified.
	 * Otherwise, use the default value (PREFIX/device-id)
	 */

	if (deviceid_dir != NULL)
	{
		struct stat buf;

		if (stat(deviceid_dir, &buf) == 0)
		  	if (S_ISDIR(buf.st_mode))
			{
				size_t sz = strlen(deviceid_dir) + strlen("device-id") + 2;
				if ((fname = malloc(sz)) != NULL)
					snprintf(fname, sz, "%s/%s", deviceid_dir, "device-id");
			}
		if (fname == NULL)
			fname = deviceid_dir;
	}    
	else
		fname = DEVICEID;


	/* check if we have a device id */

	if (access (fname, R_OK) == 0)
	{
		f = fopen (fname, "r");
		if (!f) { perror(fname); return NULL;}
		fscanf(f, "%255s", buf);
    device_id = strdup(buf);
		fclose (f);

	}
	else
	{
		/* update device id */

		if (myname != NULL)
			strlcat(hostname, myname, sizeof(hostname));
		else
			assert (gethostname(hostname, MAXHOSTNAMELEN) == 0);
		 
		time (&clock);
   
		now= localtime (&clock);
		assert (now != NULL);

		snprintf(buf, sizeof (buf), "%s-%02d-%02d-%02d-%02d-%02d-%02d",
				hostname,
				now->tm_year + 1900,
				now->tm_mon + 1,
				now->tm_mday,
				now->tm_hour,
				now->tm_min,
				now->tm_sec);

		f = fopen (fname, "w");
		if (!f) { perror(fname); return NULL;} 
		fprintf(f, "%s", buf);
		fclose (f);
    
    device_id = strdup(buf);
	}    

	return device_id; 
}



void info_content(xmlNodePtr node)
{
	xmlNewTextChild (node, NULL, "DEVICEID", get_device_id());
}
