<?php


/*
 * uploadfile Command Line Interface.
 *
 * Use this PHP script to upload a new agent in the OCS database.
 *
 * Usage:  upload_cli.php /path/to/the/new/agent
 *
 * Note: the name of the agent MUST follow the following format:
 *
 *    <agent name>-<platform>.<revision-number>
 *
 * i.e.: ocs-agent-sparcsolaris8.1004
 *
 *
 * Please update the following variables according to your installation.
 *
 */


$_CONFIG['DB_SERVER'] ="capvert";
$_CONFIG['DB_USER']   ="ocs";
$_CONFIG['DB_PASSWD'] ="ocs";
$_CONFIG['DB_NAME']   ="ocsweb";


/*
 * do not change anything after this line.
 */ 
 

$ARGV=$_SERVER['argv'];

if ( ($file=$ARGV[1])=="")
{

	printf ("Usage : %s new-agent \n\n", $ARGV[0]);
	exit (0);
}

if (! file_exists ($file))
{
	printf("** Error : file '%s' does not exist\n", $file);
	exit (1);
}

if (! (preg_match("/(\S+)-([^\-\.]+)\.(\d+)/", basename($file), $matches)))
{
	printf("** Error: file '%s' has invalid format: should be <agent name>-<platform>.<revision number>\n", $file);
	exit (1);
}

$agent_name=$matches[1]. "-" . $matches[2];
$agent_platform=$matches[2];
$agent_version=$matches[3];

$db = @mysql_connect ($_CONFIG['DB_SERVER'] , $_CONFIG['DB_USER']  , $_CONFIG['DB_PASSWD'] );
if (!$db)
{
	printf("** Error: can not connect to MySQL server %s: %s\n", 
			$_CONFIG['DB_SERVER'] ,
			mysql_error());
	exit (1);
}

if (! (@mysql_select_db ($_CONFIG['DB_NAME'] , $db)))
{
	printf("** Error: can not select database '%s': %s\n", 
			$_CONFIG['DB_NAME'],
			mysql_error());
	exit(1);
}

$file_content = addslashes(fread(fopen($file, "r"), filesize($file)));
if (!$file_content) {
	printf("** Error: can not read file '%s'\n", $file);
	exit (1);
}

$sql_query = sprintf("INSERT INTO files (NAME, VERSION, OS, CONTENT) VALUES ('%s','%s','%s','%s')", 
	$agent_name,
	$agent_version,
	$agent_platform,
	$file_content);

if (! @mysql_query ($sql_query, $db))
{
		printf("** Error: insertion failed: %s\n", mysql_error());
		exit (1);
}

mysql_close ($db);

printf("** Database updated successfully...\n");

exit (0);
?>


